#ifndef WORDRECORD_H
#define WORDRECORD_H
#include <stdio.h>
#include <stdint.h>
#include <stdbool.h>

struct _WordRecord {
   char*    Word;
   uint32_t Freq;
};

typedef struct _WordRecord WordRecord;

void     WordRecord_Init(WordRecord* const pWR, const char* const pWord, uint32_t Frequency);
char*    WordRecord_Word(const WordRecord* const pWR);
uint32_t WordRecord_Frequency(const WordRecord* const pWR);
bool     WordRecord_Increment(WordRecord* const pWR);
bool     WordRecord_Decrement(WordRecord* const pWR);
bool     WordRecord_equals(const WordRecord* const pLeft, const WordRecord* const pRight);
void     WordRecord_Clear(WordRecord* const pWR);
void     WordRecord_Print(const WordRecord* const pWR, FILE *fp);

#endif

