// test driver for DList debugging example
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "DList.h"
#include "WordRecordDT.h"

#define NUMWORDS 5

void printList(DList* pL, FILE* fp);

int main() {

   char* Words[NUMWORDS];
   Words[0] = "zero";
   Words[1] = "one";
   Words[2] = "two";
   Words[3] = "three";
   Words[4] = "four";

   DList myList;
   DList_Init(&myList);

   WordRecord WR;

   for (int i = 0; i < NUMWORDS; i++) {
      WordRecordDT *pWRDT = malloc( sizeof(WordRecordDT) );
      assert( pWRDT != NULL );
 
      WordRecord_Init(&WR, Words[i], i);
      WordRecordDT_Init(pWRDT, &WR);

      DList_PushBack(&myList, &pWRDT->node);
   }

   printList(&myList, stdout);
   fprintf(stdout, "\n");

   while ( !DList_Empty(&myList) ) {

      DNode* current = DList_PopBack(&myList);
      WordRecordDT *pWRDT = DList_Entry(current, WordRecordDT, node);
      WordRecord_Print(&pWRDT->WR, stdout);
      fprintf(stdout, "\n");
   }

   return 0;
}

void printList(DList* pL, FILE* fp) {

   DNode* e = DList_Head(pL);

   while ( (e = DList_Next(e)) != DList_End(pL)) {

      WordRecordDT *pWRDT = DList_Entry(e, WordRecordDT, node);

      WordRecord_Print(&pWRDT->WR, fp);

      fprintf(fp, "\n");
   }
}


